#include "../../sf.h"

#include "jni.h"

#include <unistd.h>

void SFAndroidMain();

namespace sf
{
namespace core
{

extern "C" void Java_com_stargaze_sf_GameThread_runGame(JNIEnv* _env, jobject _this)
{
    g_JavaEnv = _env;
    g_GameThread = g_JavaEnv->NewGlobalRef(_this);

    jclass game_thread_class = JNIGetClass("com/stargaze/sf/GameThread");

	jmethodID get_ext_files_dir = JNIGetObjectMethod(game_thread_class, "getExternalsFilesDir", "()Ljava/lang/String;");
	jstring filesdir = (jstring)core::g_JavaEnv->CallObjectMethod(g_GameThread, get_ext_files_dir);

	int len = core::g_JavaEnv->GetStringLength(filesdir);
	jboolean is_copy; //unused
	const jchar* chars = core::g_JavaEnv->GetStringChars(filesdir, &is_copy);

	char buff[512];
	for (int i = 0; i < len; ++i)
		buff[i] = chars[i];
	buff[len] = 0;
	
	core::g_JavaEnv->ReleaseStringChars(filesdir, chars);

    core::g_JavaEnv->DeleteLocalRef(filesdir);

	chdir(buff);

    SFAndroidMain();
}

} // core
} // sf
